`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2022/04/09 22:15:06
// Design Name: 
// Module Name: registerFile
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`include "utils.v"

module registerFile(
        input               clk,
        input       [4:0]   rs1,
        input       [4:0]   rs2,
        input       [4:0]   rd,
        input               regwr,
        input       [31:0]  busw,
        output  reg [31:0]  busa,
        output  reg [31:0]  busb
    );
    
    reg [31:0]  registers[0:31];
    integer i;
    
    initial begin
        for (i = 0; i < 32; i = i+1) begin
            registers[i] = 32'b0;
        end
    end
    
    always @(*) begin // read
        busa = registers[rs1];
        busb = registers[rs2];
    end
    
    always @(posedge clk) begin // write
        if (regwr == `Enable) begin
            if (rd != 5'b0) registers[rd] = busw;
        end
    end
endmodule
